const { compare } = require("../helpers/bcrypt");
const { token } = require("../helpers/jwt");
const { admin } = require("../models");
class AdminController {
  static async registerAdmin(req, res, next) {
    try {
      const { username, password } = req.body;
      const data = await admin.create({ username, password });
      res.status(201).json(data);
    } catch (error) {
      next(error);
    }
  }

  static async loginAdmin(req, res, next) {
    try {
      const { username, password } = req.body;
      if (!username) throw { name: "required_username" };
      if (!password) throw { name: "required_password" };

      const data = await admin.findOne({ where: { username } });
      if (!data) throw { name: "username_invalid" };
      const verif = compare(password, data.password);
      if (!verif) throw { name: "password_invalid" };
      const access_token = token({ id: data.id }, 1000);
      res.status(200).json({ access_token, id: data.id });
    } catch (error) {
      next(error);
    }
  }

  static async getOneAdmin(req, res, next) {
    try {
      const { id } = req.user;
      const data = await admin.findByPk(id);
      res.status(200).json(data);
    } catch (error) {
      next(error);
    }
  }
}

module.exports = AdminController;
