const { compare, hash } = require("../helpers/bcrypt");
const { verifyToken, token } = require("../helpers/jwt");
const { user, member } = require("../models");
const nodemailer = require("nodemailer");

let transporter = nodemailer.createTransport({
  host: "ende.iixcp.rumahweb.net",
  port: 465,
  secure: true, // true for 465, false for other ports
  auth: {
    user: "no-reply@kelaskedua.com", // your cPanel email address
    pass: "kelaskedua29", // your cPanel email password
  },
});

class authController {
  static async getAllUser(req, res, next) {
    try {
      const data = await user.findAll();
      res.status(200).json(data);
    } catch (err) {
      next(err);
    }
  }
  static async findUserById(req, res, next) {
    try {
      const { id } = req.params;
      const data = await user.findByPk(id, { include: [{ model: member }] });
      res.status(200).json(data);
    } catch (err) {
      next(err);
    }
  }
  static async registerUser(req, res, next) {
    try {
      const { fullName, username, password, email, phone } = req.body;
      const data = await user.create({
        fullName,
        username,
        password,
        email,
        phone,
      });
      const tok = token({ id: data.id, isActive: false }, 18000);

      // mail sender
      const html = `
        <h1>Hai ${username}</h1>
        <h1><a href="http://localhost:3000/auth/verify/${tok}">Verification</a></h1>
        `;
      const mailOptions = {
        from: "no-reply@kelaskedua.com",
        to: "mhmmadas38@gmail.com",
        subject: "Verification email | kelaskedua.com",
        html: html,
      };

      transporter.sendMail(mailOptions, function (error, info) {
        if (error) {
          console.log(error);
        } else {
          console.log("Email sent: " + info.response);
        }
        res.status(201).json({ token: tok });
      });
    } catch (err) {
      next(err);
    }
  }
  static async verifyUser(req, res, next) {
    try {
      const { id } = req.params;

      const token = verifyToken(id);
      if (token?.data === "token_expired") throw { name: "token_expired" };

      const data = await user.findByPk(token.id);
      if (!data) throw { name: "user_not_found" };
      await user.update(
        { isActive: true },
        {
          where: {
            id: token.id,
          },
        }
      );
      res.status(200).json({ message: "account has been actived" });
    } catch (err) {
      next(err);
    }
  }

  static async loginUser(req, res, next) {
    try {
      const { email, username, password } = req.body;
      const { email: mail, username: users } = req.query;
      let payload = {
        where: {},
      };
      if (mail) {
        if (!email) throw { name: "required_username" };
        payload.where.email = email;
      } else if (users) {
        if (!username) throw { name: "required_username" };
        payload.where.username = username;
      }
      if (!password) throw { name: "required_password" };

      console.log(payload);

      const data = await user.findOne(payload);

      if (!data) throw { name: "username_invalid" };
      if (!data.isActive) throw { name: "not_active" };
      const verif = compare(password, data.password);
      if (!verif) throw { name: "password_invalid" };
      const access_token = token({ id: data.id }, 1000);
      res.status(200).json({ access_token, id: data.id });
    } catch (err) {
      next(err);
    }
  }

  static async resendEmail(req, res, next) {
    try {
      const { email } = req.body;
      const users = await user.findOne({
        where: {
          email,
        },
      });
      if (!users) throw { name: "user_not_found" };
      const tok = token({ id: users.id, isActive: false }, 7200);

      // mail sender
      const html = `
        <h1>Hai ${users.username}</h1>
        <h1><a href="http://localhost:3000/auth/verify/${tok}">Verification</a></h1>
        `;
      const mailOptions = {
        from: "no-reply@kelaskedua.com",
        to: "mhmmadas38@gmail.com",
        subject: "Verification email | kelaskedua.com",
        html: html,
      };

      transporter.sendMail(mailOptions, function (error, info) {
        if (error) {
          console.log(error);
        } else {
          console.log("Email sent: " + info.response);
        }
        res.status(200).json({ message: "success" });
      });
    } catch (err) {
      next(err);
    }
  }

  static async forgetPassword(req, res, next) {
    try {
      const { email } = req.body;
      const users = await user.findOne({ where: { email } });
      if (!users) throw { name: "user_not_found" };

      const tok = token({ id: users.id, isActive: false }, 7200);

      const html = `
        <h1>Hai ${users.username}</h1>
        <h1><a href="http://localhost:3000/auth/forget_password/${tok}">Verification</a></h1>
        `;
      const mailOptions = {
        from: "no-reply@kelaskedua.com",
        to: "mhmmadas38@gmail.com",
        subject: "Change Password | kelaskedua.com",
        html: html,
      };

      transporter.sendMail(mailOptions, function (error, info) {
        if (error) {
          console.log(error);
        } else {
          console.log("Email sent: " + info.response);
        }
        res.status(200).json({ message: "success" });
      });
    } catch (error) {
      next(error);
    }
  }

  static async changePassword(req, res, next) {
    try {
      const { id } = req.params;
      const { password } = req.body;
      const token = verifyToken(id);
      if (token?.data === "token_expired") throw { name: "token_expired" };

      const data = await user.findByPk(token.id);
      if (!data) throw { name: "user_not_found" };
      await user.update(
        { password: hash(password) },
        {
          where: {
            id: token.id,
          },
        }
      );
      res.status(200).json({ message: "Password has been changed" });
    } catch (error) {
      next(err);
    }
  }
}
module.exports = authController;
