const { course: Course, module: Modules, topic: Topic } = require("../models");

class CourseController {
  static async getAllCourse(req, res, next) {
    try {
      const data = await Course.findAll();
      res.status(200).json(data);
    } catch (error) {
      next(error);
    }
  }
  static async getOneCourse(req, res, next) {
    try {
      const { id } = req.params;
      const data = await Course.findByPk(+id);
      if (!data) throw { name: "course_not_found" };
      res.status(200).json(data);
    } catch (error) {
      next(error);
    }
  }

  static async createCourse(req, res, next) {
    try {
      const { thumbnail } = req.files;
      const { title } = req.body;
      const data = await Course.create({ title, thumbnail: thumbnail.name });

      // upload image terbaru
      if (!thumbnail)
        if (!/^image/.test(thumbnail.mimetype)) return res.sendStatus(400);
      thumbnail.mv(process.cwd() + "/upload/courses/" + thumbnail.name);

      res.status(200).json({ message: "success" });
    } catch (error) {
      next(error);
    }
  }

  static async deleteCourse(req, res, next) {
    try {
      const { id } = req.params;
      const course = await Course.findByPk(id);
      if (!course) throw { name: "course_not_found" };
      await Course.destroy({
        where: {
          id,
        },
      });
      res
        .status(200)
        .json({ message: `Course ${course.title} berhasil di hapus` });
    } catch (error) {
      console.log(error);
    }
  }
}
module.exports = CourseController;
