const { compare, hash } = require("../helpers/bcrypt");
const { user, member } = require("../models");
const fs = require("fs");

class MemberController {
  static async ChangePhotoProfile(req, res, next) {
    try {
      const { myFile } = req.files;
      console.log(req.files);
      const { id } = req.user;
      const data = await member.findOne({ where: { userId: id } });
      if (!data) {
        await member.create({
          userId: id,
        });
      }

      const pictName = Math.floor(Math.random() * 10000 * 999).toString();

      //   delete image sebelumnya
      if (data.photo !== null) {
        fs.unlinkSync(process.cwd() + "/upload/" + data.photo);
      }

      // upload image terbaru
      if (!myFile) return res.sendStatus(400);
      if (!/^image/.test(myFile.mimetype)) return res.sendStatus(400);
      myFile.mv(process.cwd() + "/upload/" + pictName);
      //   myFile.mv(process.cwd() + "/upload/" + myFile.name);

      //   update photo member
      await member.update({ photo: pictName }, { where: { userId: id } });
      res.status(200).json({ message: "success" });
    } catch (error) {
      next(error);
    }
  }
  static async editProfile(req, res, next) {
    try {
      const { id } = req.user;
      const { fullName, phone, username } = req.body;
      const users = await user.findOne({ where: { username } });
      if (users.id !== id) throw { name: "username_unique" };
      const data = await user.findByPk(id);
      if (!data) throw { name: "user_not_found" };
      await user.update({ fullName, phone, username }, { where: { id } });
      res.status(200).json({ message: "acount has been updated" });
    } catch (error) {
      next(error);
    }
  }

  static async removePhoto(req, res, next) {
    try {
      const { id } = req.user;
      const data = await member.findOne({ where: { userId: id } });
      if (!data) throw { name: "user_not_found" };
      if (data.photo) {
        fs.unlinkSync(process.cwd() + "/upload/" + data.photo);
      }
      await member.update({ photo: null }, { where: { userId: id } });
      res.status(200).json({ message: "Removed Photo" });
    } catch (error) {
      next(error);
    }
  }

  static async changePasswordMember(req, res, next) {
    try {
      const { id } = req.user;
      const { oldPassword, password } = req.body;
      const data = await user.findByPk(id);
      const valid = compare(oldPassword, data.password);
      if (!valid) throw { name: "password_invalid" };
      await user.update(
        { password: hash(password) },
        {
          where: {
            id,
          },
        }
      );
      res.status(200).json({ message: "Password has been changed" });
    } catch (error) {
      next(error);
    }
  }

  static async aboutMember(req, res, next) {
    try {
      const { id } = req.user;
      const { title, instagram, youtube, tiktok, linkedin } = req.body;
      const data = await member.findOne({ where: { userId: id } });
      if (!data) {
        await member.create({ userId: id });
      }
      await member.update(
        {
          title,
          instagram,
          youtube,
          tiktok,
          linkedin,
        },
        {
          where: {
            userId: id,
          },
        }
      );
      res.status(200).json({ message: "member has been updated" });
    } catch (error) {
      next(error);
    }
  }
}
module.exports = MemberController;
