const { module: Module, course: Course } = require("../models");

class ModuleController {
  static async moduleByCourse(req, res, next) {
    try {
      const { id } = req.params;
      const module = await Module.findAll({ where: { courseId: id } });
      if (!module) throw { name: "module_not_found" };
      res.status(200).json(module);
    } catch (error) {
      next(error);
    }
  }
  static async moduleByName(req, res, next) {
    try {
      const { title } = req.query;
      const course = await Course.findOne({ where: { title } });
      const module = await Module.findAll({ where: { courseId: course.id } });
      if (!module) throw { name: "module_not_found" };
      res.status(200).json(module);
    } catch (error) {
      next(error);
    }
  }
  static async createModule(req, res, next) {
    try {
      const { title, courseId } = req.body;
      console.log(req.body);
      const data = await Module.create({ title, courseId: +courseId });
      res.status(201).json({ message: "Module has been created" });
    } catch (error) {
      next(error);
    }
  }

  static async removeModule(req, res, next) {
    try {
      const { id } = req.params;
      const module = await Module.findByPk(id);
      if (!module) throw { name: "module_not_found" };
      Module.destroy({ where: { id } });
      res.status(200).json({ message: "Module has been delete" });
    } catch (error) {
      next(error);
    }
  }
}

module.exports = ModuleController;
