const express = require("express");
const app = express();
const cors = require("cors");
const router = require("./routers");
const errorHandler = require("./middleware/errorHandler");
const fileUpload = require("express-fileupload");
const port = 4000;

app.use(fileUpload());
app.use(express.json());
app.use(express.urlencoded({ extended: true }));
app.use(express.static("upload"));
app.use(cors());
app.use(router);
app.use(errorHandler);

app.listen(port, () => {
  console.log(`server kelasKedua is running on port ${port}`);
});
