const { verifyToken } = require("../helpers/jwt");

async function Authentication(req, res, next) {
  try {
    const { access_token } = req.headers;
    if (!access_token) throw { name: "unauthorized" };
    const token = verifyToken(access_token);
    if (token?.data === "token_expired") throw { name: "token_expired" };
    req.user = {
      id: token.id,
    };
    next();
  } catch (error) {
    next(error);
  }
}

module.exports = Authentication;
