function errorHandler(err, req, res, next) {
  console.log(err);
  let status = 500;
  let message = "Internal server error";

  if (
    err.name === "SequelizeValidationError" ||
    err.name === "SequelizeUniqueConstraintError"
  ) {
    status = 400;
    message = err.errors[0].message;
  } else if (err.name === "user_not_found") {
    status = 404;
    message = "User not found";
  } else if (err.name === "required_username") {
    status = 400;
    message = "Username required";
  } else if (err.name === "required_password") {
    status = 400;
    message = "Password required";
  } else if (err.name === "username_invalid") {
    status = 400;
    message = "Username is not valid";
  } else if (err.name === "password_invalid") {
    status = 400;
    message = "Password is not valid";
  } else if (err.name === "not_active") {
    status = 400;
    message = "Account not active";
  } else if (err.name === "unauthorized") {
    status = 401;
    message = "Invalid token";
  } else if (err.name === "user_not_found") {
    status = 404;
    message = "user not found";
  } else if (err.name === "token_expired") {
    status = 401;
    message = "Token expired";
  } else if (err.name === "username_unique") {
    status = 400;
    message = "Username tidak tersedia";
  } else if (err.name === "course_not_found") {
    status = 404;
    message = "Course tidak tersedia";
  } else if (err.name === "module_not_found") {
    status = 404;
    message = "Module tidak tersedia";
  } else if (err.name === "topic_not_found") {
    status = 404;
    message = "Topik tidak tersedia";
  } else if (err.name === "freebies_not_found") {
    status = 404;
    message = "Freebies tidak tersedia";
  } else if (err.name === "highlight_rrequired") {
    status = 400;
    message = "Highlight is required";
  }
  res.status(status).json({ message });
}

module.exports = errorHandler;
