"use strict";
const { Model } = require("sequelize");
module.exports = (sequelize, DataTypes) => {
  class freebies extends Model {
    /**
     * Helper method for defining associations.
     * This method is not a part of Sequelize lifecycle.
     * The `models/index` file will call this method automatically.
     */
    static associate(models) {
      // define association here
      freebies.hasMany(models.freebiesImage, {
        foreignKey: "freebiesId",
      });
      freebies.belongsTo(models.user, { foreignKey: "userId" });
    }
  }
  freebies.init(
    {
      title: {
        type: DataTypes.STRING,
        allowNull: false,
        validate: {
          notNull: {
            msg: "Title is required",
          },
          notEmpty: {
            msg: "Title is required",
          },
        },
      },
      thumbnail: {
        type: DataTypes.STRING,
        allowNull: false,
        validate: {
          notNull: {
            msg: "Thumbnail is required",
          },
          notEmpty: {
            msg: "Thumbnail is required",
          },
        },
      },
      donate: DataTypes.STRING,
      description: {
        type: DataTypes.TEXT,
        allowNull: false,
        validate: {
          notNull: {
            msg: "Description is required",
          },
          notEmpty: {
            msg: "Description is required",
          },
        },
      },
      linkDownload: {
        type: DataTypes.STRING,
        allowNull: false,
        validate: {
          notNull: {
            msg: "Link download is required",
          },
          notEmpty: {
            msg: "Link download is required",
          },
        },
      },
      status: DataTypes.STRING,
      userId: DataTypes.INTEGER,
      linkDonate: DataTypes.STRING,
    },
    {
      sequelize,
      modelName: "freebies",
      hooks: {
        beforeCreate: (freebies) => {
          freebies.status = "pending";
        },
      },
    }
  );
  return freebies;
};
