"use strict";
const { Model } = require("sequelize");
module.exports = (sequelize, DataTypes) => {
  class topic extends Model {
    /**
     * Helper method for defining associations.
     * This method is not a part of Sequelize lifecycle.
     * The `models/index` file will call this method automatically.
     */
    static associate(models) {
      // define association here
      topic.belongsTo(models.module, { foreignKey: "moduleId" });
      topic.belongsTo(models.course, { foreignKey: "courseId" });
    }
  }
  topic.init(
    {
      title: {
        type: DataTypes.STRING,
        allowNull: false,
        validate: {
          notNull: {
            msg: "Title is required",
          },
          notEmpty: {
            msg: "Title is required",
          },
        },
      },
      video: {
        type: DataTypes.STRING,
        allowNull: false,
        validate: {
          notNull: {
            msg: "Video link is required",
          },
          notEmpty: {
            msg: "Video link is required",
          },
        },
      },
      duration: {
        type: DataTypes.STRING,
        allowNull: false,
        validate: {
          notNull: {
            msg: "Duration video is required",
          },
          notEmpty: {
            msg: "Duration video is required",
          },
        },
      },
      description: {
        type: DataTypes.TEXT,
        allowNull: false,
        validate: {
          notNull: {
            msg: "Description is required",
          },
          notEmpty: {
            msg: "Description is required",
          },
        },
      },
      moduleId: {
        type: DataTypes.INTEGER,
        allowNull: false,
        validate: {
          notNull: {
            msg: "Module id is required",
          },
          notEmpty: {
            msg: "Module id is required",
          },
        },
      },
      courseId: {
        type: DataTypes.INTEGER,
        allowNull: false,
        validate: {
          notNull: {
            msg: "Course id is required",
          },
          notEmpty: {
            msg: "Course id is required",
          },
        },
      },
    },
    {
      sequelize,
      modelName: "topic",
    }
  );
  return topic;
};
