const express = require("express");
const modules = require("./module");
const topic = require("./topic");
const {
  registerAdmin,
  loginAdmin,
  getOneAdmin,
} = require("../controllers/adminController");
const {
  createCourse,
  deleteCourse,
} = require("../controllers/courseController");
const {
  createModule,
  removeModule,
} = require("../controllers/moduleController");
const {
  updateTopic,
  createTopic,
  removeTopic,
} = require("../controllers/topicController");
const Authentication = require("../middleware/authentication");
const { updateFreebiesStatus } = require("../controllers/freebiesController");
const admin = express.Router();

admin.post("/regist", registerAdmin);
admin.post("/login", loginAdmin);

admin.use(Authentication);
admin.get("/", getOneAdmin);
// course
admin.post("/course", createCourse);
admin.delete("/course/:id", deleteCourse);

// module
admin.post("/module", createModule);
admin.delete("/module/:id", removeModule);

// topic
admin.post("/topic", createTopic);
admin.patch("/topic/:id", updateTopic);
admin.delete("/topic/:id", removeTopic);

// freebies
admin.patch("/freebies/:id", updateFreebiesStatus);

module.exports = admin;
