const express = require("express");
const {
  getAllUser,
  findUserById,
  registerUser,
  verifyUser,
  loginUser,
  resendEmail,
  forgetPassword,
  changePassword,
} = require("../controllers/authController");
const auth = express.Router();

auth.get("/", getAllUser);

auth.post("/register", registerUser);
auth.post("/login", loginUser);
auth.post("/forget-password", forgetPassword);
auth.patch("/forget-password/:id", changePassword);

auth.post("/resend", resendEmail);

auth.get("/:id", findUserById);

auth.patch("/:id", verifyUser);

module.exports = auth;
