const express = require("express");
const {
  getAllFreebies,
  getFreebiesByUser,
  updateFreebiesStatus,
  createFreebies,
  removeFreebies,
  getOneFreebies,
} = require("../controllers/freebiesController");
const Authentication = require("../middleware/authentication");
const freebies = express.Router();

freebies.get("/", getAllFreebies);
freebies.get("/:id", getOneFreebies);

freebies.use(Authentication);
freebies.post("/", createFreebies);
freebies.get("/by/user", getFreebiesByUser);
freebies.delete("/:id", removeFreebies);

module.exports = freebies;
