const express = require("express");
const {
  ChangePhotoProfile,
  editProfile,
  removePhoto,
  changePasswordMember,
  aboutMember,
} = require("../controllers/memberController");
const Authentication = require("../middleware/authentication");

const member = express.Router();

member.use(Authentication);
member.post("/photo-profile", ChangePhotoProfile);
member.post("/edit-profile", editProfile);
member.get("/remove-photo", removePhoto);
member.patch("/change-password", changePasswordMember);
member.patch("/about", aboutMember);

module.exports = member;
